#include "mapdefs.hh"

MAP_BEGIN

static const v3 verts[] =
{
#define XMI  50
#define YMI  50
#define XMA 450
#define YMA 450
    /* 0,1,2,3, 4,5,6,7 */
    {XMI,YMI, 0},
    {XMI,YMA, 0},
    {XMA,YMA, 0},
    {XMA,YMI, 0},
    {XMI,YMI,200},
    {XMI,YMA,200},
    {XMA,YMA,200},
    {XMA,YMI,200},
#undef XMI
#undef YMI
#undef XMA
#undef YMA
    
    /* 8,9,10,11, 12,13,14,15 */
    {200,100, 0},
    {300,100, 0},
    {200,200, 0},
    {210,200, 0},
    {290,200, 0},
    {300,200, 0},
    {290, 40, 0},
    {210, 40, 0},
    
    /* 16,17,18,19, 20,21,22,23 */
    {200,100,150},
    {300,100,150},
    {200,200,150},
    {210,200,100},
    {290,200,100},
    {300,200,150},
    {290, 40,100},
    {210, 40,100},
    
    /* 24,25,26,27 */
    {-4500,-4500, 500},
    { 5000,-4500, 500},
    { 5000, 5000, 500},
    {-4500, 5000, 500},
    
    /* 28,29 */
    {-1,-1,210},
    {501,501,210},
    
    /* 30,31,32,33, 34,35,36,37 */
    {450,150, 90},
    {490,150, 90},
    {490,190, 90},
    {450,190, 90},
    {450,150,130},
    {490,150,130},
    {490,190,130},
    {450,190,130},
};

/* A field with a tunnel going through solid wall. */
static const wall walls[] =
{
#if 0
    { 1, 3,  160,170,160, 40,0}, /* floor */
#endif
#if 0
    /* 1..5 */
    { 0, 7, 150,150,150, 50,4}, /* outer wall begin */
    { 3, 6, 150,150,150, 50,4},
    { 2, 5, 150,150,150, 50,4},
    { 1, 4, 150,150,150, 50,4}, /* outer wall end */
#endif
    
#if 0
    /* 6,7,8,9, 10,11,12,13 */    
    {12,21, 160,110,150, 10,20}, /* - solid wall front */
    {13,17, 160,110,150, 10,20}, /* | solid wall side */
    { 9,16, 160,110,150, 10,20}, /* _ solid wall back */
    { 8,18, 160,110,150, 10,20}, /* | solid wall side */
    {10,19, 160,110,150, 10,20}, /* - solid wall front */
#endif

#if 0
    {11,23, 255,0,50, 50,0}, /* | inside wall edges */
    {15,22, 255,0,50, 50,0}, /* ~ */
    {14,20, 255,0,50, 50,0}, /* | */
#endif
    
#if 0
    /* 14,15 */
    {16,21, 160,110,150, 50,0}, /* subtop ceiling */
    {21,19, 160,110,150, 50,0}, /* inner ceiling */
    /* 16 */
    {12,19, 160,110,150, 50,0}, /* middle top wall */
#endif

#if 0
    {37,35, 210,240,210, 5,86}, /* mirror box */
    {32,30, 210,240,210, 5,86},
    {30,35, 210,240,210, 5,86},
    {31,36, 210,240,210, 5,86},
    {32,37, 210,240,210, 5,86},
    {33,34, 210,240,210, 5,86},
#endif
    
    /* 17 */
//  {4,6, 255,190,190, 30,90}, /* very top ceiling */

#if 1
    /* mirror hall */
    { 1, 3, 255,255,255, 40,20},
    { 0, 7, 255,255,255, 40,20},
    { 3, 6, 255,255,255, 40,20},
    { 2, 5, 255,255,255, 40,20},
    { 1, 4, 255,255,255, 40,20},
    { 4, 6, 255,255,255, 40,20},
#endif

#if 0
    {28,29, 255,130,100, 40,0}
#endif
};

MAP_END(verts, walls)
#include "map.hh"
#include "wall.hh"
#include "sphere.hh"

class Map *build(void)
{
    Map *tmp = new Map;
    
    Pigment pig;
    pig.setdefault();
#if 0
    pig.Set(0.8, 0.9, 0.9);
    pig.specmul      = 0.10;
    pig.diffmul      = 0.30;
    pig.penetration  = 0.00;

    tmp->Add(new Sphere(XYZ(250,100,100), 60, pig));
#endif

#if 1
    pig.specmul     = 0.10;
    pig.diffmul     = 0.30;
    pig.penetration = 0.70;
    pig.Set(0.8, 0.8, 1);
    tmp->Add(new Sphere(XYZ(250,200,100), 40, pig));
#endif
    
#if 0
    pig.Set(100,100,100);
    pig.specmul = 0.0;
    pig.diffmul = 1.0;
    for(unsigned a=0; a<500; ++a)
    {
        FLOAT z = drand48()*2.0 - 1.0, t = DEG2RAD(drand48()*360);
        FLOAT w = SQRT(1 - z*z), x = w * COS(t), y = w * SIN(t);
        tmp->Add(new Sphere(XYZ(x*2000, y*2000, z*2000), 10, pig));
    }
#endif

#if 1
    unsigned wcount = (sizeof walls) / (sizeof (walls[0]) );
    for(unsigned a=0; a<wcount; ++a)
    {
        MapWall *w = new MapWall(walls[a], verts);
        tmp->Add(w);
    }
#endif
    
    return tmp;
}
